Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2158697 (ITP-mathics) - Review Request: python-mathics3 - General-purpose computer algebra system
Summary: Review Request: python-mathics3 - General-purpose computer algebra system
Keywords:
Status: CLOSED ERRATA
Alias: ITP-mathics
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Michel Lind
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 2158694 2158696
Blocks: 2158956
TreeView+ depends on / blocked
 
Reported: 2023-01-06 06:29 UTC by Davide Cavalca
Modified: 2023-01-25 02:35 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2023-01-22 01:21:54 UTC
Type: ---
Embargoed:
michel: fedora-review+


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github Mathics3 mathics-core issues 728 0 None open Consider replacing lena.tif with a free image 2023-01-07 23:45:51 UTC
Github Mathics3 mathics-core issues 730 0 None open Consider replacing Namespaces.xml with a free version 2023-01-08 00:57:35 UTC
Github Mathics3 mathics-core issues 743 0 None open test_strings.py::test_string_split fails when building on Fedora 2023-01-11 16:41:07 UTC
Gitlab fedora/legal fedora-license-data issues 136 0 None opened License Review: The Project Gutenberg License 2023-01-08 00:39:33 UTC
Gitlab fedora/legal fedora-license-data issues 137 0 None opened Is the GNU FDL acceptable for content? 2023-01-08 00:39:33 UTC

Description Davide Cavalca 2023-01-06 06:29:36 UTC
Spec URL: https://dcavalca.fedorapeople.org/review/python-mathics3/python-mathics3.spec
SRPM URL: https://dcavalca.fedorapeople.org/review/python-mathics3/python-mathics3-5.0.2-1.fc38.src.rpm

Description:
Mathics is a general-purpose computer algebra system (CAS) providing a free,
open-source alternative to Mathematica.

Fedora Account System Username: dcavalca

Comment 1 Jakub Kadlčík 2023-01-06 06:33:27 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/5203848
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/frostyx/fedora-review-2158697-python-mathics3/fedora-rawhide-x86_64/05203848-python-mathics3/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

Comment 2 Michel Lind 2023-01-07 22:25:21 UTC
You might want to split out the files in /usr/lib/python3.11/site-packages/mathics/data/ExampleData/ - they have a *lot* of different licenses


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file copyright.csv is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/LicensingGuidelines/#_license_text
- Large documentation must go in a -doc subpackage. Large could be size
  (~1MB) or number of files.
  Note: Documentation size is 1218560 bytes in 5 files.
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/#_documentation

Comment 3 Michel Lind 2023-01-07 22:28:04 UTC
The rest is fine:
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file copyright.csv is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/LicensingGuidelines/#_license_text
- Large documentation must go in a -doc subpackage. Large could be size
  (~1MB) or number of files.
  Note: Documentation size is 1218560 bytes in 5 files.
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/#_documentation


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU General Public License, Version
     3", "*No copyright* GNU General Public License, Version 3", "Open
     Software License 3.0", "[generated file]". 393 files have unknown
     license. Detailed output of licensecheck in
     /home/michel/src/fedora/reviews/2158697-python-
     mathics3/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 1

python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/algorithm/__init__.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/benchmark.py 644 /usr/bin/env python
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/compile/__init__.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/compile/base.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/compile/types.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/compile/utils.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/numpy_utils/__init__.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/physchemdata.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/pymimesniffer/__init__.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/pymimesniffer/magic.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/pympler/__init__.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/builtin/pympler/asizeof.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/core/parser/operators.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/core/parser/util.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/core/rules.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/doc/utils.py 644 /usr/bin/env python3
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/docbug.py 644 /usr/bin/env python
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/docpipeline.py 644 /usr/bin/env python
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/main.py 644 /usr/bin/env python
python3-mathics3.noarch: E: non-executable-script /usr/lib/python3.11/site-packages/mathics/profile_mathics.py 644 /usr/bin/env python
python3-mathics3.noarch: W: no-manual-page-for-binary mathics
python3-mathics3.noarch: W: files-duplicate /usr/lib/python3.11/site-packages/mathics/builtin/pympler/__init__.py /usr/lib/python3.11/site-packages/mathics/algorithm/__init__.py:/usr/lib/python3.11/site-packages/mathics/builtin/pymimesniffer/__init__.py
python3-mathics3.noarch: W: files-duplicate /usr/lib/python3.11/site-packages/mathics/core/convert/__init__.py /usr/lib/python3.11/site-packages/mathics/core/__init__.py
python3-mathics3.noarch: W: files-duplicate /usr/lib/python3.11/site-packages/mathics/data/ExampleData/colors.txt /usr/lib/python3.11/site-packages/mathics/data/ExampleData/colors.json
python3-mathics3.noarch: W: file-not-utf8 /usr/share/doc/python3-mathics3/ChangeLog
 1 packages and 0 specfiles checked; 20 errors, 5 warnings, 20 badness; has taken 0.2 s 



Source checksums
----------------
https://files.pythonhosted.org/packages/source/M/Mathics3/Mathics3-5.0.2.tar.gz :
  CHECKSUM(SHA256) this package     : 659293bf49c9654c6350bb2a26d1edc0bde79d0fed280e0ebc18a585cca6f2b5
  CHECKSUM(SHA256) upstream package : 659293bf49c9654c6350bb2a26d1edc0bde79d0fed280e0ebc18a585cca6f2b5


Requires
--------
python3-mathics3 (rpmlib, GLIBC filtered):
    (python3.11dist(mathics-scanner) < 1.3~~ with python3.11dist(mathics-scanner) >= 1.2.1)
    /usr/bin/python3
    python(abi)
    python3.11dist(llvmlite)
    python3.11dist(mpmath)
    python3.11dist(numpy)
    python3.11dist(palettable)
    python3.11dist(pint)
    python3.11dist(python-dateutil)
    python3.11dist(recordclass)
    python3.11dist(requests)
    python3.11dist(sympy)



Provides
--------
python3-mathics3:
    python-mathics3
    python3-mathics3
    python3.11-mathics3
    python3.11dist(mathics3)
    python3dist(mathics3)



Diff spec file in url and in SRPM
---------------------------------
--- /home/michel/src/fedora/reviews/2158697-python-mathics3/srpm/python-mathics3.spec	2023-01-07 16:14:56.444923444 -0600
+++ /home/michel/src/fedora/reviews/2158697-python-mathics3/srpm-unpacked/python-mathics3.spec	2023-01-06 00:20:48.000000000 -0600
@@ -42,5 +42,4 @@
 
 %check
-# TODO: file an upstream bug for this
 %pytest --deselect=test/test_strings.py::test_string_split
 


Generated by fedora-review 0.9.0 (6761b6c) last change: 2022-08-23
Command line :/usr/bin/fedora-review -b 2158697 -L /home/michel/tmp/mathics/
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: Perl, PHP, Haskell, Java, Ocaml, SugarActivity, C/C++, R, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Built with local dependencies:
    /home/michel/tmp/mathics/python3-mathics-scanner-1.2.4-1.fc38.noarch.rpm
    /home/michel/tmp/mathics/python-recordclass-debugsource-0.18.1.1-1.fc38.x86_64.rpm
    /home/michel/tmp/mathics/python3-recordclass-0.18.1.1-1.fc38.x86_64.rpm
    /home/michel/tmp/mathics/python3-recordclass-debuginfo-0.18.1.1-1.fc38.x86_64.rpm

Comment 4 Davide Cavalca 2023-01-07 23:37:42 UTC
mathics/data/ExampleData/lena.tif is non-free and we'll need to strip it out of the source tarball (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=758442)

Comment 5 Davide Cavalca 2023-01-07 23:45:52 UTC
Filed https://github.com/Mathics3/mathics-core/issues/728 to request upstream to consider replacing lena.tif

Comment 6 Davide Cavalca 2023-01-08 00:39:13 UTC
Filed https://gitlab.com/fedora/legal/fedora-license-data/-/issues/136 and https://gitlab.com/fedora/legal/fedora-license-data/-/issues/137 to request legal review of the data files under Gutenberg and the FDL, as I don't see them listed for content on https://docs.fedoraproject.org/en-US/legal/allowed-licenses/

Comment 7 Davide Cavalca 2023-01-08 00:57:36 UTC
Similar issue for Namespaces.xml which is under CC BY-NC-SA, filed https://github.com/Mathics3/mathics-core/issues/730 for that one

Comment 8 Davide Cavalca 2023-01-08 23:22:40 UTC
Update on the datafiles:
- upstream is replacing lena.tif with a free image in https://github.com/Mathics3/mathics-core/pull/731
- Namespaces.xml is actually W3C, which is ok, see https://github.com/Mathics3/mathics-core/pull/733
- Legal confirmed in the linked issues that all other data files can be considered either Public Domain or not actually copyrightable, so we're good there

Comment 9 Davide Cavalca 2023-01-08 23:55:50 UTC
Spec URL: https://dcavalca.fedorapeople.org/review/python-mathics3/python-mathics3.spec
SRPM URL: https://dcavalca.fedorapeople.org/review/python-mathics3/python-mathics3-5.0.2-1.fc38.src.rpm

Changelog:
- repackage upstream tarball to replace non-free data file
- rename binary package to mathics as this is primarily an application
- add mathics-data subpackage with data files
- update license tags
- add Cython to BRs and enable it in the build

Comment 10 Jakub Kadlčík 2023-01-08 23:59:51 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/5207885
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2158697-python-mathics3/fedora-rawhide-x86_64/05207885-python-mathics3/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

Comment 13 Michel Lind 2023-01-21 19:39:36 UTC
LGTM, approved

Comment 14 Fedora Admin user for bugzilla script actions 2023-01-22 00:16:49 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/python-mathics3

Comment 15 Fedora Update System 2023-01-22 01:18:10 UTC
FEDORA-2023-2a603c6916 has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2023-2a603c6916

Comment 16 Fedora Update System 2023-01-22 01:21:54 UTC
FEDORA-2023-2a603c6916 has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2023-01-23 00:35:45 UTC
FEDORA-2023-fbb955dd0f has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2023-fbb955dd0f

Comment 18 Fedora Update System 2023-01-23 00:35:56 UTC
FEDORA-2023-99c173ba9b has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2023-99c173ba9b

Comment 19 Fedora Update System 2023-01-25 01:46:55 UTC
FEDORA-2023-fbb955dd0f has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 20 Fedora Update System 2023-01-25 02:35:48 UTC
FEDORA-2023-99c173ba9b has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.